#ifndef ANALYSIS_EX_H
#define ANALYSIS_EX_H

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TParticle.h>
#include <TObject.h>
#include <TFormula.h>
#include <TLorentzVector.h>
#include "TClonesArray.h"
#include <vector>
#include <string>

#include "Utilities/ExRootAnalysis/interface/ExRootTreeReader.h"
#include "Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h"
#include "Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h"

#include "Utilities/ExRootAnalysis/interface/TSimpleArray.h"

#include "Utilities/ExRootAnalysis/interface/BlockClasses.h"

#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>

using namespace std;

class Analysis_Ex 
{
public :

  Analysis_Ex(string CardWithCuts,string LogName);  
  ~Analysis_Ex();
  
  void Run(ExRootTreeReader *treeReaderGen, ExRootTreeReader *treeReaderRec, ExRootTreeReader *treeReaderTrig);//Analyze de l'event
  void WriteOutput(string LogName);

private :

  int total, cut_trig,cut_1,cut_2;

  //******** Thresholds definition ***********
  float INV_MASS_LL;
  float PT_ELEC,PT_MUON;

  TSimpleArray<TRootElectron> SubArrayEl(const TClonesArray *ELEC,float pt);
  TSimpleArray<TRootMuon> SubArrayMu(const TClonesArray *MUON,float pt);

};

#endif
